package com.swiveltechnologies.client;

import java.io.*;
import java.util.Properties;
import javax.servlet.http.*;

@SuppressWarnings("serial")
public class SCImageProxy extends HttpServlet {
    /* (non-Java-doc)
     * @see javax.servlet.http.HttpServlet#doGet(HttpServletRequest request, HttpServletResponse response)
     */
    protected void doGet(HttpServletRequest request, HttpServletResponse response)
            throws IOException {
        //Load the settings from the session
        HttpSession session = request.getSession(false);
        Properties props = (Properties)session.getAttribute("settings");

        //Create an instance of the PINsafeClient and setup with the settings
        PINsafeClient sc = new PINsafeClient(props);

        String sessionID = request.getParameter("sessionid");
        if (sessionID == null || "".equals(sessionID)) {
            // Start the session if not given
            String username = "";
            if (request.getParameter("username") != null) {
                username = request.getParameter("username");
            }

            sessionID = sc.startSession(username);
        }

        //Get the input stream for the image
        InputStream is = sc.singleChannelImage(sessionID);

        //Ask the browser not to cache
        response.setHeader("Cache-Control", "no-store");
        response.setHeader("Pragma", "no-cache");
        response.setHeader("Expires", "0");

        //Get the output stream
        OutputStream os = response.getOutputStream();

        //Copy the data
        int read;
        byte[] buf = new byte[1024];
        while ((read = is.read(buf, 0, buf.length)) > 0) {
            os.write(buf, 0, read);
        }

        //Done
        is.close();
        response.flushBuffer();
    }
}