/* Check that a username has been entered */
function check_username() {
    var username;
    username = document.getElementById("username");

    if (username.value == "") {
        alert("Error: You must enter a username.");
        username.focus();
        return false;
    } else {
        return true;
    }
}

/* Check that the otc for the current pin has been entered and that the otcs for
 * the new pin match */
function check_otcs() {
    var otc, newotc, newotc2;
    otc = document.getElementById("otc");
    newotc = document.getElementById("newotc");
    newotc2 = document.getElementById("newotc2");

    if (otc.value == "") {
       	alert("Error: You must enter your One Time code for your current PIN.");
        otc.focus();
        return false;
    }

    if (newotc.value == "") {
        alert("Error: You must enter the One Time Code for you new PIN.");
        newotc.focus();
        return false;
    }

    if (newotc.value != newotc2.value) {
        alert("Error: The entered One Time Codes for your new PIN do not match.");

        newotc.value = "";
        newotc2.value = "";
        newotc.focus();

        return false;
    } else {
        return true;
    }
}

/* Check that the otc for the current pin has been entered and that the otcs for
 * the new pin match */
function check_pins() {
    otc = document.getElementById("otc");
    newotc = document.getElementById("newotc");
    newotc2 = document.getElementById("newotc2");
    password = document.getElementById("newpassword");
    newpassword = document.getElementById("newpassword2");

     if ((newpassword != null) && (newpassword.value != password.value)) {
        alert("The entered passwords do not match");
        password.focus();
        return false;

    }
    if (otc.value == "") {
        alert("Error: You must enter your current PIN.");
        otc.focus();
        return false;
    }

    if (newotc.value == "") {
        alert("Error: You must enter your new PIN.");
        newotc.focus();
        return false;
    }

    if (newotc.value != newotc2.value) {
        alert("Error: The entered new PINs do not match.");

        newotc.value = "";
        newotc2.value = "";
        newotc.focus();

        return false;
    } else {
        return true;
    }
}

/* Set the focus to the username field if no username is present, otherwise
 * set focus to the otc field */
function set_focus() {
    if (document.getElementById("username").value == "") {
        document.getElementById("username").focus();
    } else {
        document.getElementById("otc").focus();
    }
}

/* Enabled/disable buttons as appropriate */
function enable_buttons() {
    /* Need a username to start a session */
    if (document.getElementById("username").value == "") {
        document.getElementById("sessionstart").disabled = true;
    } else {
        document.getElementById("sessionstart").disabled = false;
    }

    /* Need all fields to perform a pin change */
    if ((document.getElementById("username").value == "") ||
        (document.getElementById("otc").value == "") ||
        (document.getElementById("newotc").value == "") ||
        (document.getElementById("newotc2").value == "")) {
        document.getElementById("changepin").disabled = true;
    } else {
        document.getElementById("changepin").disabled = false;
    }
}

/* Try to be more intelligent about handling enter presses in the form */
function handle_enter(e) {
    var code;
    if (!e)
        e = window.event;
    if (e.keyCode)
        code = e.keyCode;
    if (e.which)
        code = e.which;

    if (code == 13) {
        /* Enter key was pressed */
        if (document.getElementById("turing") || !document.getElementById("changepin").disabled) {
            /* Already have an image or all the fields are filled - perform a pin change */
            if (check_otcs()) {
                document.getElementById("action").value = "changepin";
                document.getElementById("changepin-form").submit();
            }
        } else {
            /* No image, start a session */
            if (check_username()) {
                document.getElementById("action").value = "sessionstart";
                document.getElementById("changepin-form").submit();
            }
        }
        return false;
    } else {
        /* Other keypress, let it pass */
        return true;
    }
}